"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = require("react");
var context_1 = __importDefault(require("../context"));
var noop_1 = __importDefault(require("../helpers/noop"));
/*export interface Props {
  [key: string]: any;
}*/
var useField = function (props) {
    var form = react_1.useContext(context_1["default"]);
    var name = props.name, _a = props.onChange, onChange = _a === void 0 ? noop_1["default"] : _a, _b = props.onFocus, onFocus = _b === void 0 ? noop_1["default"] : _b, _c = props.onBlur, onBlur = _c === void 0 ? noop_1["default"] : _c, _d = props.validate, validate = _d === void 0 ? noop_1["default"] : _d, rest = __rest(props, ["name", "onChange", "onFocus", "onBlur", "validate"]);
    var willMount = react_1.useRef(true);
    if (willMount.current) {
        form.setField(name).mount(props);
    }
    react_1.useEffect(function () {
        willMount.current = false;
        return form.setField(name).unmount;
    }, []);
    var _e = form.getField(name), type = _e.type, value = _e.value, multiple = _e.multiple;
    var error = form.getMeta(name).error;
    var handleChange = react_1.useCallback(function (event) {
        form.setField(name).value(event);
        onChange(event);
    }, [name]);
    var handleFocus = react_1.useCallback(function (event) {
        form.setField(name).meta('touched', true);
        onFocus(event);
    }, [name]);
    var handleBlur = react_1.useCallback(function (event) {
        form.setField(name).value(event);
        onBlur(event);
    }, [name]);
    return __assign({ input: __assign({ name: name }, (type !== 'select' && {
            type: type
        }), (type === 'checkbox' && {
            checked: Boolean(value)
        }), (type !== 'checkbox' && {
            value: value
        }), { multiple: multiple, onChange: handleChange, onFocus: handleFocus, onBlur: handleBlur }), meta: {
            error: error
        } }, rest);
};
exports["default"] = useField;
